dir = package.searchpath("main", package.path):match("(.*)main.lua")

-- Ready recorder in mp3 format
if RFirst then
    RFirst = 1
else
    RFirst = 2
end

if RFirst == 2 then
    RCount = 1
end

if RFirst == 1 then
    RCount = RCount + 1
end

if RCount > 2 then
    RCount = 1
end

switch RCount
case 1
    require "import"
    import "android.content.Context"
    import "android.os.Vibrator"
    import "java.io.FileOutputStream"
    import "java.io.OutputStreamWriter"
    import "java.io.BufferedReader"
    import "java.io.InputStreamReader"
    import "android.media.MediaRecorder"
    import "android.media.MediaScannerConnection"
    import "java.io.File"
    import "java.io.FileInputStream"
    import "java.text.SimpleDateFormat"
    import "java.util.Date"
    import "android.content.ContentValues"
    import "android.provider.MediaStore"

    folderPath = "/storage/emulated/0/Jieshuo Recording"
    folder = File(folderPath)

    if not folder.exists() then
        success = folder.mkdirs()
    end

    fileName = "Record 1.mp3"
    fileIndex = 1
    outputFile = folderPath .. "/" .. fileName

    while File(outputFile).exists() do
        fileIndex = fileIndex + 1
        fileName = "record " .. fileIndex .. ".mp3"
        outputFile = folderPath .. "/" .. fileName
    end

    isRecording = false

    function stopRecording()
        if isRecording then
            mediaRecorder.stop()
            mediaRecorder.release()
            mediaRecorder = nil
            isRecording = false
            MediaScannerConnection.scanFile(this, { outputFile }, nil, nil)
            values = ContentValues()
            values.put(MediaStore.MediaColumns.DATA, outputFile)
            values.put(MediaStore.MediaColumns.TITLE, fileName)
            values.put(MediaStore.MediaColumns.MIME_TYPE, "audio/mp3")
            this.getContentResolver().insert(MediaStore.Audio.Media.EXTERNAL_CONTENT_URI, values)
        end
    end

    function startRecording()
        if not isRecording then
            mediaRecorder = MediaRecorder()
            mediaRecorder.setAudioSource(MediaRecorder.AudioSource.MIC)
            mediaRecorder.setOutputFormat(MediaRecorder.OutputFormat.MPEG_4)
            mediaRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.AAC)
            mediaRecorder.setAudioEncodingBitRate(96000) --
            mediaRecorder.setAudioSamplingRate(44100)
            mediaRecorder.setAudioChannels(2) -- 2 channels for stereo
            mediaRecorder.setOutputFile(outputFile)
            mediaRecorder.prepare()
            mediaRecorder.start()
            isRecording = true
        end
    end

    task(200, function()
        service.asyncSpeak("Recording started")
    end)

    task(500, function()
        startRecording()
        context = activity or service
        vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)
        if vibrator.hasVibrator() then
            vibrator.vibrate(100)
        end
    end)

    return true

case 2
    stopRecording()
    service.asyncSpeak("Recording has stopped and saved to storage/Jieshuo Recording")
    task(600, function()
    end)
end